//#######################################################################################        
//#### These shaders , has been greatly impoved and many new features added.         ####         
//#### This has now been made available for free to ALL GameGuru users.              ####         
//#### If you like to support the work involved in these shader updates ( a lot ),   ####        
//#### You can order a copy of GG Loader from daily3d.com , but its not needed.      ####           
//#### http://www.daily3d.com , or give me a e-mail plemsoft@plemsoft.com            ####
//#### This is mainly made to make GG look like GG Loader. But is part of a larger   ####
//#### 3D developer kit for AGK called "GG Loader". Best Regards: Preben Eriksen.    ####
//#######################################################################################  

//This shader provides an automatic adaptive bloom effect based on screen brightness to scale the bloom effect
//released under creative commons license by attribution: http://creativecommons.org/licenses/by-sa/3.0/
//Shader code by Mark Blosser email: mjblosser@gmail.com website: www.mjblosser.com

#include "settings.fx"

//####
//#define SHOW_SSAO           /** Uncomment this to display the bare SSAO output */
//#define SHOW_UNBLURRED      /** Useful to fine-tune your unblurred AO. Also random noise generation is cool */
static float nearZ = 1.0;
static float farZ = 10000.0; // was 100
#define FAR_PLANE_Z (9000.0) // was 90
// if enabled, fades out AO between FADE_Z and FAR_PLANE_Z
//#define FADE_OUT
#define FADE_Z (8000.0) // was 80
/** Quality. Range is (1..30). */
#define NUM_SAMPLES (9)
/** More detailed distribution of the AO (imo). You'll need to tweak the intensity parameter accordingly */
#define HIGH_QUALITY
/** World-space AO radius in scene units (r).  e.g., 1.0m */
/** Usually you'll want tweak projScale parameter in conjunction with this. They *are* related */
/** Radius is also linked to intensity such as intensity / radius^6 (see intensityDivR6 below) 
*except* for HIGH_QUALITY mode */
//static const float radius = 4.8; // was 2.4
float radius = 4.8; // was 2.4
/** Bias to avoid AO in smooth corners, e.g., 0.01m */
/** Use this to push the darkening farther away from the models so it is not stuck on the geometry itself */
//static const float bias = 1.2f;//0.08f;

static const float bias = 1.48f;

/** The height in pixels of a 1m object if viewed from 1m away.
You can compute it from your projection matrix.  The actual value is just
a scale factor on radius; you can simply hardcode this to a constant (~500)
and make your radius value unitless (...but resolution dependent.)  */
/** This setting tends to extend the range of occlusion, much like a radius increase
but without affecting the intensity */
static const float projScale = 1.2f;// was 1.2f;
/** Comment this line to not take pixel brightness into account (the higher the more AO will blend into bright surfaces) */
//#define LUMINANCE_CONSIDERATION
extern float luminosity_threshold = 0.6;
/** Falloff function type */
   // 1: From the HPG12 paper
   // 2: Smoother transition to zero (lowers contrast, smoothing out corners). [Recommended]
   // 3: Medium contrast (which looks better at high radii), no division.
   // 4: Low contrast, no division operation
#define FALLOFF_FUNCTION 1
/** Epsilon (read the SAO paper for details). Basically larger values (ie. 0.02) avoid overdarkening within cracks */
const float epsilon = 0.001;
/** Increase to make edges crisper. Decrease to reduce temporal flicker. */
#define EDGE_SHARPNESS     (1.0)
/** Step in 2-pixel intervals since we already blurred against neighbors in the
first AO pass.  This constant can be increased while R decreases to improve
performance at the expense of some dithering artifacts.
Morgan found that a scale of 3 left a 1-pixel checkerboard grid that was
unobjectionable after shading was applied but eliminated most temporal incoherence
from using small numbers of sample taps.
*/
#define SCALE               (3) // (1)
/** Filter radius in pixels. This will be multiplied by SCALE. */
#define R                   (5)
/////////////////////////////////////////////////// END OF TWEAKABLE VALUES ///////////////////////////////////////////////////////////
static const int ROTATIONS[] = { 1, 1, 2, 3, 2, 5, 2, 3, 2,
3, 3, 5, 5, 3, 4, 7, 5, 5, 7,
9, 8, 5, 5, 7, 7, 7, 8, 5, 8,
11, 12, 7, 10, 13, 8, 11, 8, 7, 14,
11, 11, 13, 12, 13, 19, 17, 13, 11, 18,
19, 11, 11, 14, 17, 21, 15, 16, 17, 18,
13, 17, 11, 17, 19, 18, 25, 18, 19, 19,
29, 21, 19, 27, 31, 29, 21, 18, 17, 29,
31, 31, 23, 18, 25, 26, 25, 23, 19, 34,
19, 27, 21, 25, 39, 29, 17, 21, 27 };
// This is the number of turns around the circle that the spiral pattern makes.  This should be prime to prevent
// taps from lining up.  This particular choice was tuned for NUM_SAMPLES == 9
static const int NUM_SPIRAL_TURNS = ROTATIONS[NUM_SAMPLES-1];
/** radius*radius*/
//static const float radius2 = (radius*radius);
float radius2 = 0;//(radius*radius);
//static float intensityDivR6 = intensity / pow(radius, 6.0f);
// [Boulotaur2024] Not used anymore -> mipmaps cause flashing (probably due to my poor implementation)
// If using depth mip levels, the log of the maximum pixel offset before we need to switch to a lower 
// miplevel to maintain reasonable spatial locality in the cache
// If this number is too small (< 3), too many taps will land in the same pixel, and we'll get bad variance that manifests as flashing.
// If it is too high (> 5), we'll get bad performance because we're not using the MIP levels effectively
// #define LOG_MAX_OFFSET 3
// // This must be less than or equal to the MAX_MIP_LEVEL defined in SSAO.cpp
// #define MAX_MIP_LEVEL (5)
#ifndef USE_SRGB
#define USE_SRGB true
#endif
// SAO END
                      
string Description = "Adaptive Bloom by bond1 & TGC";
string Thumbnail = "Blur.png";
float2 ViewSize : ViewSize;
float deltatime : deltatime;

//very hacky way to get special matrices from DBP
float4x4 g_View : View;
float4x4 g_ViewInv : ViewInverse;
float4x4 g_Projection : Projection;
float4x4 ViewProjection : ViewProjection;
float4x4 g_ViewProjectionMatrix : WorldViewTranspose;
float4x4 g_previousViewProjectionMatrix : WorldViewProjectionTranspose; // it passes the previous ViewProjectionMatrix in
float4x4 g_CameraViewMatrix : ViewProjectionTranspose; // it passes the camera zero view matrix (post process view matrix is the quad, not the camera zero view)

// For Poisson Disk Gather Technique for Depth Of Field (crude but effective)
static const float2 PoissonSamples[64] =
{
    float2(-0.5119625f, -0.4827938f),
    float2(-0.2171264f, -0.4768726f),
    float2(-0.7552931f, -0.2426507f),
    float2(-0.7136765f, -0.4496614f),
    float2(-0.5938849f, -0.6895654f),
    float2(-0.3148003f, -0.7047654f),
    float2(-0.42215f, -0.2024607f),
    float2(-0.9466816f, -0.2014508f),
    float2(-0.8409063f, -0.03465778f),
    float2(-0.6517572f, -0.07476326f),
    float2(-0.1041822f, -0.02521214f),
    float2(-0.3042712f, -0.02195431f),
    float2(-0.5082307f, 0.1079806f),
    float2(-0.08429877f, -0.2316298f),
    float2(-0.9879128f, 0.1113683f),
    float2(-0.3859636f, 0.3363545f),
    float2(-0.1925334f, 0.1787288f),
    float2(0.003256182f, 0.138135f),
    float2(-0.8706837f, 0.3010679f),
    float2(-0.6982038f, 0.1904326f),
    float2(0.1975043f, 0.2221317f),
    float2(0.1507788f, 0.4204168f),
    float2(0.3514056f, 0.09865579f),
    float2(0.1558783f, -0.08460935f),
    float2(-0.0684978f, 0.4461993f),
    float2(0.3780522f, 0.3478679f),
    float2(0.3956799f, -0.1469177f),
    float2(0.5838975f, 0.1054943f),
    float2(0.6155105f, 0.3245716f),
    float2(0.3928624f, -0.4417621f),
    float2(0.1749884f, -0.4202175f),
    float2(0.6813727f, -0.2424808f),
    float2(-0.6707711f, 0.4912741f),
    float2(0.0005130528f, -0.8058334f),
    float2(0.02703013f, -0.6010728f),
    float2(-0.1658188f, -0.9695674f),
    float2(0.4060591f, -0.7100726f),
    float2(0.7713396f, -0.4713659f),
    float2(0.573212f, -0.51544f),
    float2(-0.3448896f, -0.9046497f),
    float2(0.1268544f, -0.9874692f),
    float2(0.7418533f, -0.6667366f),
    float2(0.3492522f, 0.5924662f),
    float2(0.5679897f, 0.5343465f),
    float2(0.5663417f, 0.7708698f),
    float2(0.7375497f, 0.6691415f),
    float2(0.2271994f, -0.6163502f),
    float2(0.2312844f, 0.8725659f),
    float2(0.4216993f, 0.9002838f),
    float2(0.4262091f, -0.9013284f),
    float2(0.2001408f, -0.808381f),
    float2(0.149394f, 0.6650763f),
    float2(-0.09640376f, 0.9843736f),
    float2(0.7682328f, -0.07273844f),
    float2(0.04146584f, 0.8313184f),
    float2(0.9705266f, -0.1143304f),
    float2(0.9670017f, 0.1293385f),
    float2(0.9015037f, -0.3306949f),
    float2(-0.5085648f, 0.7534177f),
    float2(0.9055501f, 0.3758393f),
    float2(0.7599946f, 0.1809109f),
    float2(-0.2483695f, 0.7942952f),
    float2(-0.4241052f, 0.5581087f),
    float2(-0.1020106f, 0.6724468f),
};

float PreBloomBoost 
<
   string UIWidget = "slider";
   float UIMax = 4.0;
   float UIMin = 0.0;
   float UIStep = 0.1;
> = 2.0f;

float BloomThreshold 
<
   string UIWidget = "slider";
   float UIMax = 1.0;
   float UIMin = 0.0;
   float UIStep = 0.05;
> = 0.9;

float PostContrast
<
   string UIWidget = "slider";
   float UIMax = 5.0;
   float UIMin = 0.0;
   float UIStep = 0.001;
> = 2.0f;

float PostBrightness
<
   string UIWidget = "slider";
   float UIMax = 1.0;
   float UIMin = 0.0;
   float UIStep = 0.001;
> = 0.4f;

float4 ScreenColor
<   string UIType = "Screen Color Effect";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float4 OverallColor
<   string UIType = "Overall Color Effect";
> = {1.0f, 1.0f, 1.0f, 1.0f};

float4 Vignette
<   string UIType = "Vignette";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float4 Motion
<   string UIType = "Motion";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float4 DepthOfField
<   string UIType = "DepthOfField";
> = {0.0f, 0.0f, 0.0f, 0.0f};

// SAOSettings = SAORadius, SAOIntensity, SAOQuality, LensFlare
float4 SAOSettings
<   string UIType = "SAOSettings";
> = {0.25f, 0.5f, 1.0f, 0.5f};

float4 HudFogDistAndAlpha : Diffuse
<   string UIName =  "Hud Fog Dist And Alpha";    
> = {0.0f, 0.0f, 0.0f, 0.0f};

//9 sample gauss filter, declare in pixel offsets convert to texel offsets in PS
float4 GaussFilter[9] =
{
    { -1,  -1, 0,  0.0625 },
    { -1,   1, 0,  0.0625 },
    {  1,  -1, 0,  0.0625 },
    {  1,   1, 0,  0.0625 },
    { -1,   0, 0,  0.125  },
    {  1,   0, 0,  0.125  },
    {  0,  -1, 0,  0.125 },
    {  0,   1, 0,  0.125 },
    {  0,   0, 0,  0.25 },
};

// RENDERCOLORTARGET only used to inform that a part of this uses dynamic render targets
texture frame : RENDERCOLORTARGET
< 
   string ResourceName = "";
   float2 ViewportRatio = {1.0,1.0 };
>;

sampler2D frameSampler = sampler_state {
    Texture = < frame >;
    MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;
    AddressU = Clamp; AddressV = Clamp;
};

texture DepthTex : RENDERCOLORTARGET
< 
   string ResourceName = "";
   float2 ViewportRatio = {1.0,1.0 };
>;

sampler2D depthRawSampler = sampler_state 
{
    Texture = < DepthTex >;
    MinFilter = Point; 
   MagFilter = Point; 
   MipFilter = Point;
    AddressU = Clamp; 
   AddressV = Clamp;
};

texture buffer1Img : RENDERCOLORTARGET 
< 
   string ResourceName = ""; 
   //int width = 1920;
   //int height = 1080;
>;
sampler2D buffer1ImgSamp = sampler_state {
    Texture = < buffer1Img >;
    MinFilter = Point; MagFilter = Point; MipFilter = Point;
    AddressU = Clamp; AddressV = Clamp;
};
texture buffer2Img : RENDERCOLORTARGET 
< 
   string ResourceName = ""; 
   //int width = 1920;
   //int height = 1080;
>;
sampler2D buffer2ImgSamp = sampler_state {
    Texture = < buffer2Img >;
    MinFilter = Point; MagFilter = Point; MipFilter = Point;
    AddressU = Clamp; AddressV = Clamp;
};
texture combineFrameImg : RENDERCOLORTARGET 
< 
   string ResourceName = ""; 
   //int width = 1920;
   //int height = 1080;
>;
sampler2D combineFrameSamp = sampler_state {
    Texture = < combineFrameImg >;
    MinFilter = Point; MagFilter = Point; MipFilter = Point;
    AddressU = Clamp; AddressV = Clamp;
};

//2x2 average luminosity texture
texture AvgLum2x2Img : RENDERCOLORTARGET 
< 
   string ResourceName = ""; 
   int width = 2;
   int height = 2;
>;
sampler2D AvgLum2x2ImgSamp = sampler_state {
    Texture = < AvgLum2x2Img >;
    MinFilter = Point; MagFilter = Point; MipFilter = Point;
    AddressU = Clamp; AddressV = Clamp;
};

//Average scene luminosity stored in 1x1 texture 
texture AvgLumFinal : RENDERCOLORTARGET 
< 
   string ResourceName = ""; 
   int width = 1;
   int height = 1;
>;
sampler2D AvgLumFinalSamp = sampler_state {
    Texture = < AvgLumFinal >;
    MinFilter = Point; MagFilter = Point; MipFilter = Point;
    AddressU = Clamp; AddressV = Clamp;
};

//reduce image to 1/8 size for brightpass
texture BrightpassImg : RENDERCOLORTARGET
< 
   string ResourceName = "";
   //float2 ViewportRatio = {0.125,0.125 };
   int width = 512;
   int height = 384;
   
>;
sampler2D BrightpassImgSamp = sampler_state {
    Texture = < BrightpassImg >;
    MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;
    AddressU = Clamp; AddressV = Clamp;
};

//blur texture 1
texture Blur1Img : RENDERCOLORTARGET
< 
   string ResourceName = "";
   //float2 ViewportRatio = {0.125,0.125 };
   int width = 512;
   int height = 384;
   
>;
sampler2D Blur1ImgSamp = sampler_state {
    Texture = < Blur1Img >;
    MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;
    AddressU = Clamp; AddressV = Clamp;
};

//blur texture 2
texture Blur2Img : RENDERCOLORTARGET
< 
   string ResourceName = "";
   //float2 ViewportRatio = {0.125,0.125 };
   int width = 512;
   int height = 384;
   
>;
sampler2D Blur2ImgSamp = sampler_state {
    Texture = < Blur2Img >;
    MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;
    AddressU = Clamp; AddressV = Clamp;
};

//depth of field texture
texture DepthOfFieldImg : RENDERCOLORTARGET
< 
   string ResourceName = "";
>;
sampler2D DepthOfFieldImgSamp = sampler_state {
    Texture = < DepthOfFieldImg >;
    MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;
    AddressU = Clamp; AddressV = Clamp;
};

struct input 
{
   float4 pos : POSITION;
   float2 uv : TEXCOORD0;
};
 
struct output 
{
   float4 pos: POSITION;
   float2 uv: TEXCOORD0;
};

output VS( input IN ) 
{
   output OUT;

   //quad needs to be shifted by half a pixel.
    //Go here for more info: http://www.sjbrown.co.uk/?article=directx_texels
   float4 oPos = float4( IN.pos.xy + float2( -1.0f/ViewSize.x, 1.0f/ViewSize.y ),0.0,1.0 );
   OUT.pos = oPos;
   float2 uv = (IN.pos.xy + 1.0) / 2.0;
   uv.y = 1 - uv.y; 
   OUT.uv = uv;
   
   return OUT;   
}

struct VSOUT
{
   float4 vertPos : POSITION0;
   float2 UVCoord : TEXCOORD0;
};
struct VSIN
{
   float4 vertPos : POSITION0;
   float2 UVCoord : TEXCOORD0;
};
VSOUT FrameVS(VSIN IN) {
   VSOUT OUT = (VSOUT)0.0f;
   
   //OUT.vertPos = IN.vertPos;
   //OUT.UVCoord = IN.UVCoord;
   
   float4 oPos = float4( IN.vertPos.xy + float2( -1.0f/ViewSize.x, 1.0f/ViewSize.y ),0.0,1.0 );
   OUT.vertPos = oPos;
   float2 uv = (IN.vertPos.xy + 1.0) / 2.0;
   uv.y = 1 - uv.y; 
   OUT.UVCoord = uv;   
   
   return OUT;
}

float3 reconstructCSFaceNormal(float3 C)
{
    return normalize(cross(ddy(C), ddx(C)));
}

float2 tapLocation(int sampleNumber, float spinAngle, out float ssR)
{
    // Radius relative to ssR
    float alpha = float(sampleNumber + 0.5) * (1.0 / NUM_SAMPLES);
    float angle = alpha * (NUM_SPIRAL_TURNS * 6.28) + spinAngle;
    ssR = alpha;
    float sin_v, cos_v;
    sincos(angle, sin_v, cos_v);
    return float2(cos_v, sin_v);
}

float CSZToKey(float z)
{
    return clamp(z * (1.0 / FAR_PLANE_Z), 0.0, 1.0);
}

float LinearizeDepth(float depth)
{
   return rcp(depth * ((farZ - nearZ) / (-farZ * nearZ)) + farZ / (farZ * nearZ));
}

float3 getOffsetPosition(float2 ssC, float2 unitOffset, float ssR)
{
   // Derivation:
   //  mipLevel = floor(log(ssR / MAX_OFFSET));
   //int mipLevel = clamp((int)floor(log2(ssR)) - LOG_MAX_OFFSET, 0, MAX_MIP_LEVEL);
   //int mipLevel = 4;
    float2 ssP = ssR*unitOffset + ssC;
   float4 worldSpacePos = tex2D(depthRawSampler, ssP).yzwx;
   float3 P = worldSpacePos.xyz;
   P.xyz = mul ( float4(P.xyz,1), g_CameraViewMatrix ).xyz;
    return P;
}

float sampleAO(in float2 ssC, in float3 C, in float3 n_C, in float ssDiskRadius, in int tapIndex, in float randomPatternRotationAngle)
{
    // Offset on the unit disk, spun for this pixel
    float ssR;
    float2 unitOffset = tapLocation(tapIndex, randomPatternRotationAngle, ssR);
    ssR *= ssDiskRadius;

    // The occluding point in camera space
    float3 Q = getOffsetPosition(ssC, unitOffset, ssR);
    float3 v = C - Q;

    float vv = dot(v, v);
    float vn = dot(v, n_C);

   #ifdef HIGH_QUALITY
      // Addition from http://graphics.cs.williams.edu/papers/DeepGBuffer13/   
      // Epsilon inside the sqrt for rsqrt operation
      float f = max(1.0 - vv * (1.0 / radius2), 0.0); return f * max((vn - bias) * rsqrt(epsilon + vv), 0.0);
   #else
      // [Boulotaur2024] yes branching is bad but choice is good...
      // PE: yes but its a define so we might as well just uncomment what we need :)
//      [branch]
//           if( FALLOFF_FUNCTION == 1 )
               // A: From the HPG12 paper
               // Note large epsilon to avoid overdarkening within cracks
               return float(vv < radius2) * max((vn - bias) * rcp(epsilon + vv), 0.0) * radius2 * 0.6;
//            else if( FALLOFF_FUNCTION == 2 ) {
//               // B: Smoother transition to zero (lowers contrast, smoothing out corners). [Recommended]
//               float f = max(radius2 - vv, 0.0); return f * f * f * max((vn - bias) * rcp(epsilon + vv), 0.0); // / (epsilon + vv) (optimization by BartWronski)
//            }
//            else if( FALLOFF_FUNCTION == 3 )
//               // C: Medium contrast (which looks better at high radii), no division.  Note that the 
//               // contribution still falls off with radius^2, but we've adjusted the rate in a way that is
//               // more computationally efficient and happens to be aesthetically pleasing.
//               return 4.0 * max(1.0 - vv * 1.0 / radius2, 0.0) * max(vn - bias, 0.0);
//            else if( FALLOFF_FUNCTION == 4 )
//               // D: Low contrast, no division operation
//               return 2.0 * float(vv < radius * radius) * max(vn - bias, 0.0);
//            else
//               return 4.0 * max(1.0 - vv * 1.0 / radius2, 0.0) * max(vn - bias, 0.0);         
   #endif
}

void packKey(float key, out float2 p)
{
    // Round to the nearest 1/256.0
    float temp = floor(key * 256.0);
    // Integer part
    p.x = temp * (1.0 / 256.0);
    // Fractional part
    p.y = key * 256.0 - temp;
}

float unpackKey(float2 p)
{
    return p.x * (256.0 / 257.0) + p.y * (1.0 / 257.0);
}

// All noise functions are designed for values on integer scale.
// They are tuned to avoid visible periodicity for both positive and
// negative coordinates within a few orders of magnitude.
float hash(float n) { return frac(sin(n) * 1e4); }
float hash(float2 p) { return frac(1e4 * sin(17.0 * p.x + p.y * 0.1) * (0.1 + abs(sin(p.y * 13.0 + p.x)))); }
float noise1(float2 x) 
{
    float2 i = floor(x);
    float2 f = frac(x);

   // Four corners in 2D of a tile
   float a = hash(i);
    float b = hash(i + float2(1.0, 0.0));
    float c = hash(i + float2(0.0, 1.0));
    float d = hash(i + float2(1.0, 1.0));

    // Simple 2D lerp using smoothstep envelope between the values.
   // return float3(lerp(lerp(a, b, smoothstep(0.0, 1.0, f.x)),
   //         lerp(c, d, smoothstep(0.0, 1.0, f.x)),
   //         smoothstep(0.0, 1.0, f.y)));

   // Same code, with the clamps in smoothstep and common subexpressions
   // optimized away.
    float2 u = f * f * (3.0 - 2.0 * f);
   return lerp(a, b, u.x) + (c - a) * u.y * (1.0 - u.x) + (d - b) * u.x * u.y;
}

#define visibility      output.r
#define bilateralKey    output.gb

float4 SSAOCalculate(VSOUT IN) : COLOR0
{
    float4 output = float4(1,1,1,1);
  
    // Pixel being shaded 
    float2 ssC = IN.UVCoord;

    // World space point being shaded
   float4 worldSpacePosOrig = tex2D(depthRawSampler, IN.UVCoord).yzwx;
   float4 worldSpacePos = worldSpacePosOrig;
   float2 lockNoiseToWorldXY = worldSpacePos.xy;
   worldSpacePos.xyz = mul ( float4(worldSpacePos.xyz,1), g_CameraViewMatrix ).xyz;
    float3 C = worldSpacePos.xyz;
   
   bool earlyOut = C.z > FAR_PLANE_Z || C.z < 0.4f; // || any(ssC >= (SCREEN_SIZE - 8));
    [branch]
    if(earlyOut)
    {
        return output;
    }

    packKey(CSZToKey(C.z), bilateralKey);

    // Hash function used to create some noise
   float2 fixToWorld = float2((worldSpacePosOrig.x*4.0)+(worldSpacePosOrig.y*3),(worldSpacePosOrig.z*5.0)+(worldSpacePosOrig.y*2.0));
   float randomPatternRotationAngle = noise1(fixToWorld) * 10; // McGuire noise function

    // Reconstruct normals from positions. These will lead to 1-pixel black lines
    // at depth discontinuities, however the blur will wipe those out so they are not visible
    // in the final image.
   float3 n_C = reconstructCSFaceNormal(C);
   
   // SAO radius is now dynamic
   radius = 10.0 * SAOSettings.x;
   radius2 = (radius*radius);
   
    // Choose the screen-space sample radius
    float ssDiskRadius = -projScale * radius / max(C.z,0.1f);

    float sum = 0.0;
    //for (int i = 0; i < NUM_SAMPLES * SAOSettings.z; ++i) 
    for (int i = 0; i < NUM_SAMPLES; ++i) 
    {
         sum += sampleAO(ssC, C, n_C, ssDiskRadius, i, randomPatternRotationAngle);
    }
   
    const float temp = radius2 * radius;
    sum /= temp * temp;
   sum = sum * 200 * SAOSettings.y;

   // account for fog settings
    float hudfogfactor = saturate((C.z- HudFogDistAndAlpha.x)/(HudFogDistAndAlpha.y - HudFogDistAndAlpha.x));
    sum = lerp(sum,0,hudfogfactor*HudFogDistAndAlpha.w);
         
   #ifdef HIGH_QUALITY
      // Addition from http://graphics.cs.williams.edu/papers/DeepGBuffer13/
      float A = pow(max(0.0, 1.0 - sqrt(sum * (3.0 / NUM_SAMPLES))), 20.0f);
   #else
      float A = max(0.0f, 1.0f - sum);// * intensityDivR6);
   #endif

   // Bilateral box-filter over a quad for free, respecting depth edges
   // (the difference that this makes is subtle)
   if (abs(ddx(C.z)) < 0.02) {
      A -= ddx(A) * (((ssC.x - floor(ssC.x)) * 2) - 0.5);  // ssC.x & 1 -> (ssC.x - floor(ssC.x)) * 2 (McGuire tip)
   }
   if (abs(ddy(C.z)) < 0.02) {
      A -= ddy(A) * (((ssC.y - floor(ssC.y)) * 2) - 0.5);
   }

   // Anti-tone map to reduce contrast and drag dark region farther
   // (x^0.2 + 1.2 * x^4)/2.2
   // A = (pow(A, 0.2) + 1.2 * A*A*A*A) / 2.2;
   visibility = lerp(1.0, A, 1.0);
   
   #ifdef FADE_OUT
   visibility = lerp(visibility,1.0,saturate((C.z-FADE_Z)/(FAR_PLANE_Z-FADE_Z)));
   #endif

   #ifdef SHOW_UNBLURRED
      return float4(visibility, visibility, visibility, 1.0);
   #endif
   
    return output;
}

//////////////////////////////////////////////////////////////////////////////////////////////

/** Type of data to read from source.  This macro allows
the same blur shader to be used on different kinds of input data. */
#define VALUE_TYPE        float

/** Swizzle to use to extract the channels of source. This macro allows
the same blur shader to be used on different kinds of input data. */
#define VALUE_COMPONENTS   r
#define VALUE_IS_KEY       0

/** Channel encoding the bilateral key value (which must not be the same as VALUE_COMPONENTS) */
#define KEY_COMPONENTS     gb

// Gaussian coefficients
static const float gaussian[] =
//   { 0.356642, 0.239400, 0.072410, 0.009869 };
//   { 0.398943, 0.241971, 0.053991, 0.004432, 0.000134 };  // stddev = 1.0
//  { 0.153170, 0.144893, 0.122649, 0.092902, 0.062970 };  // stddev = 2.0
  { 0.111220, 0.107798, 0.098151, 0.083953, 0.067458, 0.050920, 0.036108 }; // stddev = 3.0

#define  result         output.VALUE_COMPONENTS
#define  keyPassThrough output.KEY_COMPONENTS

float4 BlurBL(VSOUT IN, uniform sampler2D bufferTexSamp, uniform bool isBlurHorizontal) : COLOR0
{
   float4 output = float4(1,1,1,1);
   float2 ssC = IN.UVCoord;
   float4 temp = tex2D(bufferTexSamp, ssC);

    keyPassThrough = temp.KEY_COMPONENTS;
    float key = unpackKey(keyPassThrough);
   float sum = temp.VALUE_COMPONENTS;
   
   //[branch]
    //if (key >= 0.999) {
    //    // Sky pixel (if you aren't using depth keying, disable this test)
    //    result = sum;
    //    return output;
    //}

   // Base weight for depth falloff.  Increase this for more blurriness,
   // decrease it for better edge discrimination
   float BASE = gaussian[0];
   float totalWeight = BASE;
   sum *= totalWeight;

   [unroll]

   // pe: moved out of loop
   float2 axis = (isBlurHorizontal) ? float2(1, 0) : float2(0, 1);
   float2 PixelSize = float2(1.0/ViewSize.x,1.0/ViewSize.y);

   for (int r = -R; r <= R; ++r) 
   {
      // We already handled the zero case above.  This loop should be unrolled and the branch discarded
      if (r != 0) 
      {
         temp = tex2D(bufferTexSamp, ssC + axis * PixelSize * (r * SCALE));
         
         float tapKey = unpackKey(temp.KEY_COMPONENTS);
         float value  = temp.VALUE_COMPONENTS;

            // spatial domain: offset gaussian tap
            float weight = 0.3 + gaussian[abs(r)];
      
         // range domain (the "bilateral" weight). As depth difference increases, decrease weight.
         weight *= max(0.0, 1.0 - (800.0 * EDGE_SHARPNESS) * abs(tapKey - key));

            sum += value * weight;
            totalWeight += weight;
      } 
   }
   const float epsilon = 0.0001;
   result = sum / (totalWeight + epsilon);
   
   return float4(output.r,0,0,1);
}

float4 combine( VSOUT IN, uniform sampler2D oldFrameSamp, uniform sampler2D bufferTexSamp ) : COLOR0 
{
   float4 final = float4(tex2D(oldFrameSamp, IN.UVCoord).xyz,1);
   float ao = tex2D(bufferTexSamp, IN.UVCoord).r;
   
   #ifdef SHOW_SSAO
    return float4(ao,ao,ao,1);
   #endif
   #ifdef LUMINANCE_CONSIDERATION
    float luminance = (color.r*0.2125f)+(color.g*0.7154f)+(color.b*0.0721f);
    float white = 1.0f;
    float black = 0.0f;
    luminance = clamp(max(black,luminance-luminosity_threshold)+max(black,luminance-luminosity_threshold)+max(black,luminance-luminosity_threshold),0.0,1.0);
    ao = lerp(ao,white,luminance);
   #endif   
   final.rgb *= ao;
   return final;
}

//takes original frame image and outputs to 2x2
float4 PSReduce( output IN, uniform sampler2D srcTex ) : COLOR
{
    float4 color = tex2D( srcTex, IN.uv );
    return color;    
}

//-----------------computes average luminosity for scene-----------------------------
float4 PSGlareAmount( output IN, uniform sampler2D srcTex ) : COLOR
{
    float4 GlareAmount = 0;
    
    //sample texture 4 times with offset texture coordinates
    float4 color1= tex2D( srcTex, IN.uv + float2(-0.5, -0.5) );
    float4 color2= tex2D( srcTex, IN.uv + float2(-0.5, 0.5) );
    float4 color3= tex2D( srcTex, IN.uv + float2(0.5, -0.5) );
    float4 color4= tex2D( srcTex, IN.uv + float2(0.5, 0.5) );
    
    //average these samples
    float3 AvgColor = saturate(color1.xyz * 0.25 + color2.xyz * 0.25 + color3.xyz * 0.25 + color4.xyz * 0.25);
    
    //convert to luminance
    AvgColor = dot(float3(0.3,0.59,0.11), AvgColor);
    GlareAmount.xyz = pow(abs(AvgColor),2);
    
    //interpolation value to blend with previous frames
    GlareAmount.w = deltatime * 2;
       
    return GlareAmount;    
}

#ifdef LENSFLARE
// PE: generated in agk. static const 
int flarecolr[64] = {255,254,250,241,233,223,215,202,182,160,
135,114,98,138,157,121,79,56,51,55,
49,42,38,34,30,26,23,19,16,13,
12,12,22,43,78,135,208,251,254,255,
255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,
241,154,119,86};
int flarecolg[64] = {255,253,247,236,222,202,186,164,150,141,
140,140,139,154,123,86,52,35,30,32,
27,21,16,10,6,2,2,1,1,1,
1,1,0,0,4,22,51,62,72,87,
105,125,146,166,185,201,215,225,234,235,
205,154,97,49,22,38,95,127,118,96,
70,56,62,67};
int flarecolb[64] = {255,254,249,241,233,224,217,207,197,187,
178,169,161,165,158,148,137,126,106,85,
73,72,77,84,88,87,79,69,60,51,
45,39,36,32,25,17,15,7,2,0,
0,0,0,0,0,0,0,0,0,6,
28,53,79,99,108,81,25,0,21,67,
121,162,178,193};
        

float4 lensflarefirst( output IN, uniform sampler2D lfsrcTex ) : COLOR
{
   float3 lfBias = float3 TRIGGERLENSFLARE;
   float3 lfScale = float3( 10.0,10.0,10.0);
   float3 color = tex2D(lfsrcTex,IN.uv) - lfBias;
   return float4( max( float3(0.0,0.0,0.0) , color ) * lfScale * SAOSettings.w, 1.0 );
}


float uDispersal = 0.35; //0.35;
float uHaloWidth = 0.50; //0.55;
float uDistortion = 4.5; //4.5

float4 textureDistorted(sampler2D tex,float2 texcoord,float2 direction,float3 distortion ) {
   return float4(
   tex2D(tex, texcoord + direction * distortion.r).r,
   tex2D(tex, texcoord + direction * distortion.g).g,
   tex2D(tex, texcoord + direction * distortion.b).b,1.0);
}
float4 lensflare( output IN, uniform sampler2D srcTex ) : COLOR
{
   float2 texelSize = 1.0 / ViewSize;
   float2 texcoord = -IN.uv + float2(1.0,1.0); // flip texcoords
   float2 ghostVec = (float2(0.5,0.5) - texcoord) * uDispersal;
   float2 haloVec = (normalize(ghostVec) * uHaloWidth) ;
   float3 distortion = float3(-texelSize.x * uDistortion, 0.0 , texelSize.x * uDistortion);
   // sample ghosts
   float2 offset;
   float weight;
   float4 color = float4(0.0, 0.0, 0.0, 0.0);
              
   for (int i = 0; i < 3; ++i) {
      offset = frac(texcoord + ghostVec * float(i));
      weight = length(float2(0.5,0.5) - offset) / length(float2(0.5,0.5));
      weight = pow( abs(1.0 - weight), 10.0);
      color += tex2D(srcTex, offset)* weight;
   }

   offset = frac(texcoord + ghostVec * 4.0);
   weight = length(float2(0.5,0.5) - offset) / length(float2(0.5,0.5));
   weight = pow( abs(1.0 - weight) , 10.0);
   color += tex2D(srcTex, offset)* weight;

   float distance2Center = length(float2(0.5,0.5) - texcoord) / length(float2(0.5,0.5));
   float2 uvLensColor = frac( float2(distance2Center, 1) );

   int idx = abs( clamp( uvLensColor.x*64 , 0 , 63 )); 
   float4 lcol = float4( (flarecolr[idx])/256.0 , (flarecolg[idx])/256.0  , (flarecolb[idx])/256.0 , 1.0);
   color *= lcol;

#ifndef DISABLELENSFLAREHALO
   //sample halo:
   weight = length(float2(0.5,0.5) - frac(texcoord + haloVec)) / length(float2(0.5,0.5));
   weight = pow( abs(1.0 - weight), 5.0);
   color += (textureDistorted(srcTex, frac(texcoord + haloVec),normalize(ghostVec),distortion) * weight)*0.5;
#endif
   return float4( color.rgb ,1.0);
   //return float4(0,0,0,1);    
}
#endif
                
float4 PSBrightpass( output IN, uniform sampler2D srcTex, uniform sampler2D srcTex2  ) : COLOR
{
    //remove low luminance pixels, keeping only brightest
    float4 screen = tex2D(srcTex, IN.uv);  //original screen texture;
    float4 glaretex = tex2D(srcTex2, IN.uv);  //glareamount from 1x1 in previous pass
    float3 Brightest = saturate(screen.xyz - BloomThreshold);

#ifdef LENSFLARE

#ifdef HQLENSFLARE
    Brightest.xyz = pow( abs(Brightest.xyz) ,2) * (1+glaretex.xyz) * PreBloomBoost;
#else
    Brightest.xyz = pow( abs(Brightest.xyz) ,2) * (1+glaretex.xyz) * clamp(PreBloomBoost-1.15,0.0,4.0);
#endif
#else
    Brightest.xyz = pow( abs(Brightest.xyz) ,2) * (1+glaretex.xyz) * PreBloomBoost;
#endif
    float4 color = float4(Brightest.xyz, 1);
    return color;    
}

float4 PSBlur( output IN, uniform sampler2D srcTex ) : COLOR
{           
    float4 color = float4(0,0,0,0);
    
    //inverse view for correct pixel to texel mapping
    //float2 ViewInv = float2( 1/ViewSize.x,1/ViewSize.y);   
    
    //sample and output average colors using gauss filter samples
    //for(int i=0;i<9;i++)
    //{
    //  float4 col = GaussFilter[i].w * tex2D(srcTex,IN.uv + float2(GaussFilter[i].x * ViewInv.x*2.5, GaussFilter[i].y *ViewInv.y*2.5));  
    //  color+=col;
    //}

    float2 PixelOffsets [ 6 ];
    float BlurWeights [ 6 ];

    //linear sampling. using middle coordinate between the two texel centers
    // reduced to 5 samples for same quality as normal.
    PixelOffsets[ 0 ] = float2( 0.0, 0 );
    PixelOffsets[ 1 ] = float2( 1.3846153846, 1.3846153846 );
    PixelOffsets[ 2 ] = float2( 3.2307692308, 3.2307692308 );
    //PixelOffsets[ 3 ] = float2( 3.2307692308+1.3846153846, 0 );
    PixelOffsets[ 3 ] = float2( -1.3846153846, -1.3846153846 );
    PixelOffsets[ 4 ] = float2( -3.2307692308, -3.2307692308 );
    //PixelOffsets[ 6 ] = float2( -3.2307692308-1.3846153846, 0 );
    BlurWeights [ 0 ] = 0.2270270270;
    BlurWeights [ 1 ] = 0.3162162162;
    BlurWeights [ 2 ] = 0.0702702703;
    //BlurWeights [ 3 ] = 0.026995;
    BlurWeights [ 3 ] = 0.3162162162;
    BlurWeights [ 4 ] = 0.0702702703;
    //BlurWeights [ 6 ] = 0.026995;

    float2 scale = float2( 1/ViewSize.x,1/ViewSize.y);
     for (int i = 0; i < 5; i++) {   
      //convert pixel offsets into texel offsets via the inverse view values. 
      color += tex2D( srcTex, IN.uv + PixelOffsets[i].xy*scale ) * BlurWeights[i];
    }   
    return color;
}
//PE TODO: Better to do it Vertical and then Hortizental in 2 runs.
float4 BlurV( output IN, uniform sampler2D srcTex ) : COLOR
{
    float4 color = float4(0,0,0,0);
    float2 PixelOffsets [ 6 ];
    float BlurWeights [ 6 ];
    //linear sampling. using middle coordinate between the two texel centers
    PixelOffsets[ 0 ] = float2( 0.0, 0 );
    PixelOffsets[ 1 ] = float2( 1.3846153846, 0 );
    PixelOffsets[ 2 ] = float2( 3.2307692308, 0 );
    PixelOffsets[ 3 ] = float2( -1.3846153846, 0 );
    PixelOffsets[ 4 ] = float2( -3.2307692308, 0 );
    BlurWeights [ 0 ] = 0.2270270270;
    BlurWeights [ 1 ] = 0.3162162162;
    BlurWeights [ 2 ] = 0.0702702703;
    BlurWeights [ 3 ] = 0.3162162162;
    BlurWeights [ 4 ] = 0.0702702703;
    float2 scale = float2( 1/ViewSize.x,1/ViewSize.y);
    for (int i = 0; i < 5; i++) {   
      //convert pixel offsets into texel offsets via the inverse view values. 
      color += tex2D( srcTex, IN.uv + PixelOffsets[i].xy*scale ) * BlurWeights[i];
    }   
    return color;
}
float4 BlurH( output IN, uniform sampler2D srcTex ) : COLOR
{
    float4 color = float4(0,0,0,0);
    float2 PixelOffsets [ 6 ];
    float BlurWeights [ 6 ];
    //linear sampling. using middle coordinate between the two texel centers
    PixelOffsets[ 0 ] = float2( 0.0, 0 );
    PixelOffsets[ 1 ] = float2( 1.3846153846, 0 );
    PixelOffsets[ 2 ] = float2( 3.2307692308, 0 );
    PixelOffsets[ 3 ] = float2( -1.3846153846, 0 );
    PixelOffsets[ 4 ] = float2( -3.2307692308, 0 );
    BlurWeights [ 0 ] = 0.2270270270;
    BlurWeights [ 1 ] = 0.3162162162;
    BlurWeights [ 2 ] = 0.0702702703;
    BlurWeights [ 3 ] = 0.3162162162;
    BlurWeights [ 4 ] = 0.0702702703;
    float2 scale = float2( 1/ViewSize.x,1/ViewSize.y);
    for (int i = 0; i < 5; i++) {   
      //convert pixel offsets into texel offsets via the inverse view values. 
      color += tex2D( srcTex, IN.uv + PixelOffsets[i].yx*scale ) * BlurWeights[i];
    }   
    return color;
}

float4 PSDepthOfField( output IN, uniform sampler2D srcTex ) : COLOR
{             
   float3 color = tex2D(srcTex, IN.uv).xyz;
   if( DepthOfField.y >= 0.05 ) {
      float2 ViewInv = float2( 1/ViewSize.x,1/ViewSize.y);      
      float4 worldSpacePos = tex2D(depthRawSampler, IN.uv).yzwx;
      float fAllowMBandDOF = min(worldSpacePos.w*500,1);
      float fZDepth = max ( 0, 1.0 - (worldSpacePos.w / 7000.0f) ) * fAllowMBandDOF;
      float fCircleOfConfusion = min(max(0,(fZDepth-DepthOfField.x)*DepthOfField.y*100.0),10.0);
      float fContributions = 1;
      for(int p=0; p<64; p+=4) // 2
      {
         float2 offsetuv = PoissonSamples[p] * ViewInv * fCircleOfConfusion;
         float3 currentColor = tex2D(srcTex, IN.uv+offsetuv).xyz;  
         worldSpacePos = tex2D(depthRawSampler, IN.uv+offsetuv).yzwx;
         float fAllowMBandDOF = min(worldSpacePos.w*500,1);
         float weight = max ( 0, 1.0 - (worldSpacePos.w / 7000.0f) ) * fAllowMBandDOF;
         color += (currentColor*weight);
         fContributions += weight;
      }
      color = color / fContributions;
   }
   return float4(color,1);
}
                  
//@https://www.opengl.org/discussion_boards/showthread.php/184192-GLSL-FXAA-rendering-off-screen
#define FXAA_REDUCE_MIN (1.0/128.0)
#define FXAA_REDUCE_MUL (1.0/8.0)
#define FXAA_SPAN_MAX 8.0
                      
float4 fxaa(uniform sampler2D sampler0,float2 fcoords, float4 curcolor )
{
   float2 resolution = ViewSize; //float2(1280.0,768.0); // ViewSize
   float3 rgbNW = tex2D(sampler0, (fcoords.xy + (float2(-1.0,-1.0)/resolution)) ).xyz;
   float3 rgbNE = tex2D(sampler0, (fcoords.xy + (float2(1.0,-1.0)/resolution)) ).xyz;
   float3 rgbSW = tex2D(sampler0, (fcoords.xy + (float2(-1.0,1.0)/resolution)) ).xyz;
   float3 rgbSE = tex2D(sampler0, (fcoords.xy + (float2(1.0,1.0)/resolution)) ).xyz;
   float3 rgbM  = curcolor.xyz;
 
   float3 luma = float3(0.299, 0.587, 0.114);
   float lumaNW = dot(rgbNW, luma);
   float lumaNE = dot(rgbNE, luma);
   float lumaSW = dot(rgbSW, luma);
   float lumaSE = dot(rgbSE, luma);
   float lumaM  = dot(rgbM,  luma);
   float lumaMin = min(lumaM, min(min(lumaNW, lumaNE), min(lumaSW, lumaSE)));
   float lumaMax = max(lumaM, max(max(lumaNW, lumaNE), max(lumaSW, lumaSE))); 
   float2 dir;
   dir.x = -((lumaNW + lumaNE) - (lumaSW + lumaSE));
   dir.y =  ((lumaNW + lumaSW) - (lumaNE + lumaSE));
   float dirReduce = max((lumaNW + lumaNE + lumaSW + lumaSE) * (0.25 * FXAA_REDUCE_MUL),FXAA_REDUCE_MIN);
   float rcpDirMin = 1.0/(min(abs(dir.x), abs(dir.y)) + dirReduce);
   dir = min(float2( FXAA_SPAN_MAX,  FXAA_SPAN_MAX),max(float2(-FXAA_SPAN_MAX, -FXAA_SPAN_MAX),dir * rcpDirMin)) / resolution;
   float3 rgbA = 0.5 * (tex2D(sampler0,   fcoords.xy  + dir * (1.0/3.0 - 0.5)).xyz + tex2D(sampler0,   fcoords.xy  + dir * (2.0/3.0 - 0.5)).xyz);
   float3 rgbB = rgbA * 0.5 + 0.25 * (tex2D(sampler0,  fcoords.xy  + dir *  - 0.5).xyz + tex2D(sampler0,  fcoords.xy + dir * 0.5).xyz);
   float lumaB = dot(rgbB, luma);
   if((lumaB < lumaMin) || (lumaB > lumaMax)) {
      return( float4(rgbA,1.0) );
   } else {
      return( float4(rgbB,1.0) );
   }
}

float4 presentfxaa(output IN, uniform sampler2D srcTex ) : COLOR
{
    float2 texCoord = IN.uv;
    float4 ScreenMap = tex2D(srcTex, texCoord);
    return fxaa( srcTex , texCoord , ScreenMap );
}
 
float threshold( float thr1,  float thr2 ,  float val) {
 if (val < thr1) {return 0.0;}
 if (val > thr2) {return 1.0;}
 return val;
}

float avg_intensity( float4 pix) {
 return (pix.r + pix.g + pix.b)/3.0;
}

float4 get_pixel( float2 coords,  float dx,  float dy,uniform sampler2D srcTex) {
 return tex2D(srcTex,coords + float2(dx, dy));
}

float IsEdge( float2 coords,uniform sampler2D srcTex){
  float dxtex = 1.0 / ViewSize.x; //512.0 /*image width*/;
  float dytex = 1.0 / ViewSize.y; //512.0 /*image height*/;
  float pix[9];
  int k = -1;
  float delta;

  pix[0] = avg_intensity(get_pixel(coords,float(-1)*dxtex,float(-1)*dytex,srcTex));
  pix[1] = avg_intensity(get_pixel(coords,float(-1)*dxtex,float(0)*dytex,srcTex));
  pix[2] = avg_intensity(get_pixel(coords,float(-1)*dxtex,float(1)*dytex,srcTex));

  pix[3] = avg_intensity(get_pixel(coords,float(0)*dxtex,float(-1)*dytex,srcTex));
  pix[4] = avg_intensity(get_pixel(coords,float(0)*dxtex,float(0)*dytex,srcTex));
  pix[5] = avg_intensity(get_pixel(coords,float(0)*dxtex,float(1)*dytex,srcTex));

  pix[6] = avg_intensity(get_pixel(coords,float(1)*dxtex,float(-1)*dytex,srcTex));
  pix[7] = avg_intensity(get_pixel(coords,float(1)*dxtex,float(0)*dytex,srcTex));
  pix[8] = avg_intensity(get_pixel(coords,float(1)*dxtex,float(1)*dytex,srcTex));

  // average color differences around neighboring pixels
  delta = (abs(pix[1]-pix[7])+abs(pix[5]-pix[3]) +abs(pix[0]-pix[8])+abs(pix[2]-pix[6]) )/4.0;
  //return clamp(4.2*delta,0.0,1.0);
  return clamp( CARTOONIMPACT *delta,0.0,1.0);

}

float4 cartoon(output IN, float4 color,uniform sampler2D srcTex)
{
   color = lerp( color , float4(0.0,0.0,0.0,1.0) , IsEdge(IN.uv,srcTex) );
   return color;
}

float retroluma(float3 color) {
  return dot(color, float3(0.299, 0.587, 0.114) );
}
float retrodither4a(float2 uvpos, float brightness) {
  int x = int(fmod( uvpos.x, 4.0));
  int y = int(fmod( uvpos.y, 4.0));
  int index = x + y * 4;
  float limit = 0.0;
  if (x < 8) {
    if (index == 0) limit = 0.0625;
    if (index == 1) limit = 0.5625;
    if (index == 2) limit = 0.1875;
    if (index == 3) limit = 0.6875;
    if (index == 4) limit = 0.8125;
    if (index == 5) limit = 0.3125;
    if (index == 6) limit = 0.9375;
    if (index == 7) limit = 0.4375;
    if (index == 8) limit = 0.25;
    if (index == 9) limit = 0.75;
    if (index == 10) limit = 0.125;
    if (index == 11) limit = 0.625;
    if (index == 12) limit = 1.0;
    if (index == 13) limit = 0.5;
    if (index == 14) limit = 0.875;
    if (index == 15) limit = 0.375;
  }
  return brightness < limit ? 0.0 : 1.0;
}
float3 retrodither4(float2 uvpos, float3 color) {
  return color.rgb * retrodither4a(uvpos, retroluma(color.rgb));
}

// @ https://www.c64-wiki.com/index.php/Color
float3 bestcolorc64( float3 oldcolor )
{
   float3 c64col[27];
   // real c64 colors, mapping directly dont look good so....
//   c64col[0] = float3(0.0, 0.0, 0.0); // Black 0   CTRL  + 1    144   small square left down   0, 0, 0   #000000
//   c64col[1] = float3(255.0, 255.0, 255.0); // White   1   CTRL  + 2    5   inverted e e   255, 255, 255
//   c64col[2] = float3(136.0,0.0,0.0); // Red   2   CTRL  + 3    28   inverted pound   136, 0, 0   #880000
//   c64col[3] = float3(170.0,255.0,238.0); // Cyan   3   CTRL  + 4    159   Triangle left down   170, 255, 238   #AAFFEE
//   c64col[4] = float3(204.0,68.0,204.0); // Violet   4   CTRL  + 5    156   inverted halfchess   204, 68, 204   #CC44CC
//   c64col[5] = float3(0.0,204.0,85.0); // Green   5   CTRL  + 6    30   inverted arrow up   0, 204, 85   #00CC55
//   c64col[6] = float3(0.0,0.0,170.0); // Blue   6   CTRL  + 7    31   inverted arrow left   0, 0, 170   #0000AA
//   c64col[7] = float3(238.0,238.0,119.0); // Yellow   7   CTRL  + 8    158   inverted p   238, 238, 119   #EEEE77
//   c64col[8] = float3(221.0,136.0,85.0); // Orange   8   C=  + 1    129   inverted heart   221, 136, 85   #DD8855
//   c64col[9] = float3(102.0,68.0,0.0); // Brown   9   C=  + 2    149   inverted 1/4-circle right down   102, 68, 0   #664400
//   c64col[10] = float3(255.0,119.0,119.0); // Lightred   10   C=  + 3    150   inverted graphic-X   255, 119, 119   #FF7777
//   c64col[11] = float3(51.0,51.0,51.0); // Grey 1   11   C=  + 4    151   inverted annulus   51, 51, 51   #333333
//   c64col[12] = float3(119.0,119.0,119.0); // Grey 2   12   C=  + 5    152   inverted spade   119, 119, 119   #777777
//   c64col[13] = float3(170.0,255.0,102.0); // Lightgreen   13   C=  + 6    153   inverted line right   170, 255, 102   #AAFF66
//   c64col[14] = float3(0.0,136.0,255.0); // Lightblue   14   C=  + 7    154   inverses diamonds   0, 136, 255   #0088FF
//   c64col[15] = float3(187.0,187.0,187.0); // Grey 3   15   C=  + 8    155   inverted clubs   187, 187, 187

   // map colors.  
   // pure 128 255 colors seams to work better.
   c64col[0] = float3(0.0,0.0,0.0);
   c64col[1] = float3(0.0,0.0,128.0);
   c64col[2] = float3(0.0,0.0,255.0);
   c64col[3] = float3(0.0,128.0,0.0);
   c64col[4] = float3(0.0,128.0,128.0);
   c64col[5] = float3(0.0,128.0,255.0);
   c64col[6] = float3(0.0,255.0,0.0);
   c64col[7] = float3(0.0,255.0,128.0);
   c64col[8] = float3(0.0,255.0,255.0);
   c64col[9] = float3(128.0,0.0,0.0);
   c64col[10] = float3(128.0,0.0,128.0);
   c64col[11] = float3(128.0,0.0,255.0);
   c64col[12] = float3(128.0,128.0,0.0);
   c64col[13] = float3(128.0,128.0,128.0);
   c64col[14] = float3(128.0,128.0,255.0);
   c64col[15] = float3(128.0,255.0,0.0);
   c64col[16] = float3(128.0,255.0,128.0);
   c64col[17] = float3(128.0,255.0,255.0);
   c64col[18] = float3(255.0,0.0,0.0);
   c64col[19] = float3(255.0,0.0,128.0);
   c64col[20] = float3(255.0,0.0,255.0);
   c64col[21] = float3(255.0,128.0,0.0);
   c64col[22] = float3(255.0,128.0,128.0);
   c64col[23] = float3(255.0,128.0,255.0);
   c64col[24] = float3(255.0,255.0,0.0);
   c64col[25] = float3(255.0,255.0,128.0);
   c64col[26] = float3(255.0,255.0,255.0);
   float3 match = float3(0.0,0.0,0.0);
   float best_dot = 999999.0;
   // PE: Stupid way slow but works, need a vacation to make it faster :)
   // cybernescence / lee : got a suggestion ?
   // perhaps i generic postp color conversion texture ? could be used for all color changes.
   for (int c=26;c>=0;c--) {
      float this_dot = distance((c64col[c]/255.0),oldcolor);
      if (this_dot<best_dot) {
         best_dot=this_dot;
         match=c64col[c];
      }
   }
   return match/255.0;
}      
#ifdef LENSFLARE
float4 PSPresent( output IN, uniform sampler2D srcTex, uniform sampler2D srcTex2, uniform sampler2D srcTex3, uniform sampler2D srcTex4 ) : COLOR
#else
float4 PSPresent( output IN, uniform sampler2D srcTex, uniform sampler2D srcTex2, uniform sampler2D srcTex3 ) : COLOR
#endif  
{        
   // sample screen texture with supersampled UV's
    float4 BloomMap=tex2D( srcTex2, IN.uv );
#ifdef LENSFLARE
    float4 LensMap = tex2D( srcTex4, IN.uv ) * LENSFLAREINTENSITY;
#endif
    float4 AmtMap=tex2D( srcTex3, IN.uv );
   
   // as scene gets brighter, reduce brightness effects of post process
    float ToneLuminance = dot(AmtMap.xyz, float3(0.3, 0.59, 0.11)) * 1.5;
   
   // stores world pos and view Z 0-7000
   float4 worldSpacePos = tex2D(depthRawSampler, IN.uv).yzwx;
   
#ifdef MOTIONBLUR
   // Motion Blur effect calculation
   float4 ScreenMap = tex2D(srcTex, IN.uv );

   if( Motion.y >= 0.05 ) {
      float4 currentPos = mul(float4(worldSpacePos.xyz,1),g_ViewProjectionMatrix);
      float4 previousPos = mul(float4(worldSpacePos.xyz,1),g_previousViewProjectionMatrix);
      currentPos /= currentPos.w;
      previousPos /= previousPos.w;
      
      // this corrects the issue of reversed spiral syndrome
      float2 velocity = (currentPos.xy - previousPos.xy);
      if ( velocity.x > -0.50 && velocity.x < 0.50 ) velocity.x = 0.0f;
      if ( velocity.y > -0.40 && velocity.y < 0.40 ) velocity.y = 0.0f;
      velocity.y = -velocity.y;
      
      // blur velocity modulated by real distance
      float fAllowMB = min(worldSpacePos.w*500,1);
      float fModulatedDepth = (worldSpacePos.w/7000.0) * (1.0-(0.9+(Motion.x/10)));
      velocity = velocity * fModulatedDepth * fAllowMB * Motion.y;
      
      // Motion Blur - collect (10 samples)
      float2 texCoord = IN.uv;
      float4 color = ScreenMap;  
      velocity = velocity / 10; 
      texCoord += velocity;
      float fContributions = 1;
      for(int i = 1; i < 10; ++i, texCoord -= velocity) // 10  
      {  
         // Sample the color buffer along the velocity vector.  
         float4 currentColor = tex2D(srcTex, texCoord);
         worldSpacePos = tex2D(depthRawSampler, texCoord).yzwx;
         float fAllowMB = min(worldSpacePos.w*500,1);
         color += (currentColor*fAllowMB);
         fContributions += fAllowMB;
      }  
      
      // Average all of the samples to get the final blur color
      ScreenMap = color / fContributions;
   }
#else
    float2 texCoord = IN.uv;
    float4 ScreenMap = tex2D(srcTex, texCoord);
#endif

    // add results based scene pixel brightness
#ifdef LENSFLARE
    float4 MaxAmount = ScreenMap + BloomMap + LensMap;
#else
    float4 MaxAmount = ScreenMap + BloomMap;
#endif
    float3 final = lerp(MaxAmount, ScreenMap, ToneLuminance);

#ifndef NOCOLOREFFECT
    // add any screen color effect
    final.xyz += ScreenColor.xyz;
#endif

   // overall modulation control
    final.xyz *= OverallColor.xyz;

   // Apply contrast
   final.rgb = ((final.rgb - 0.5f) * max(PostContrast, 0)) + 0.5f;

   // Apply brightness
   final.rgb += PostBrightness;
   
    // Vignetting   
   float2 xy = ((IN.uv*2)-1) * Vignette.x;
   final *= (1.0-Vignette.y) + (Vignette.y)*pow( abs((xy.x+1.0)*(xy.y+1.0)*(xy.x-1.0)*(xy.y-1.0)), 0.25 );
   
   // final pixel color
   //return BloomMap;
#ifdef CARTOON
     //ScreenMap = cartoon(IN,ScreenMap,srcTex);
     final = cartoon(IN,float4(final,1.0),srcTex).rgb;
#endif

#ifdef RETRODITHER
     // find screenpos using ViewSize.
     final = retrodither4( (IN.uv.xy*ViewSize), final);
#endif

#ifdef RETRODITHER64
#ifndef RETRODITHER
     final = retrodither4( (IN.uv.xy*ViewSize), final);
#endif
     // convert to nearest c64 color.
     final = bestcolorc64(final);
#endif


//#ifdef FXAA
//    //ScreenMap = fxaa( srcTex , texCoord , ScreenMap );
//    final = fxaa( srcTex , texCoord , float4(final,1) ).rgb;
//#endif
 
   //return float4(LensMap.rgb,1);
   return float4(final,1);
}

technique dx9textured
<
   //specify where we want the original image to be put
   string RenderColorTarget = "frame";
>
{
#ifndef NOSAO
   pass SAOp1
   <
      string RenderColorTarget = "buffer1Img";
   >
   {
      VertexShader = compile vs_3_0 FrameVS();
      PixelShader = compile ps_3_0 SSAOCalculate();
   }
   pass SAOp2
   <
      string RenderColorTarget = "buffer2Img";
   >
   {
      VertexShader = compile vs_3_0 FrameVS();
      PixelShader = compile ps_3_0 BlurBL(buffer1ImgSamp,true);   
   }
   pass SAOp3
   <
      string RenderColorTarget = "buffer1Img";
   >
   {
      VertexShader = compile vs_3_0 FrameVS();
      PixelShader = compile ps_3_0 BlurBL(buffer2ImgSamp,false);   
   }
   pass SAOp4
   <
      string RenderColorTarget = "combineFrameImg";
   >
   {
      VertexShader = compile vs_3_0 FrameVS();
      PixelShader = compile ps_3_0 combine(frameSampler,buffer1ImgSamp);
   }
#endif

   //1. first reduce to 2x2 and save in AvgLum2x2Img
   pass Reduce2x2
   <
      string RenderColorTarget = "AvgLum2x2Img";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
#ifndef NOSAO
      PixelShader = compile ps_3_0 PSReduce( combineFrameSamp );//frameSampler );
#else
      PixelShader = compile ps_3_0 PSReduce( frameSampler );
#endif
   }
   
   //2. reduce to 1x1 and save in AvgLumFinalImg, using alpha blending to blend with previous frames
   pass Reduce1x1
   <
      string RenderColorTarget = "AvgLumFinal";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
      PixelShader = compile ps_3_0 PSGlareAmount( AvgLum2x2ImgSamp );
      AlphaBlendEnable = true;
      SrcBlend = SRCALPHA;
      DestBlend = INVSRCALPHA;
   }
   
   //3. remove low luminance pixels keeping only brightest for blurring in next pass
   pass Brightpass
   <
      string RenderColorTarget = "BrightpassImg";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
      //PixelShader = compile ps_3_0 PSBrightpass( frameSampler, AvgLumFinalSamp );
#ifndef NOSAO
      PixelShader = compile ps_3_0 PSBrightpass( combineFrameSamp, AvgLumFinalSamp );
#else
      PixelShader = compile ps_3_0 PSBrightpass( frameSampler, AvgLumFinalSamp );
#endif
   }
   
   //4. blur texture and save in Blur1Img
   pass Blur1
   <
      string RenderColorTarget = "Blur1Img";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
//      PixelShader = compile ps_3_0 PSBlur( BrightpassImgSamp );
      PixelShader = compile ps_3_0 BlurV( BrightpassImgSamp );
   }
   
   //5. repeat blur texture and save in Blur2Img
   pass Blur2
   <
      string RenderColorTarget = "Blur2Img";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
//      PixelShader = compile ps_3_0 PSBlur( Blur1ImgSamp );
      PixelShader = compile ps_3_0 BlurH( Blur1ImgSamp );
   }
   
   //6. repeat blur again
   pass Blur3
   <
      string RenderColorTarget = "Blur1Img";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
      PixelShader = compile ps_3_0 PSBlur( Blur2ImgSamp );
   }
  
//   pass Blur4
//   <
//      string RenderColorTarget = "Blur2Img";
//   >
//   {
//      ZEnable = False;
//      VertexShader = compile vs_3_0 VS();
//      PixelShader = compile ps_3_0 PSBlur( Blur1ImgSamp );
//   }
//   
//   pass Blur5
//   <
//      string RenderColorTarget = "Blur1Img";
//   >
//   {
//      ZEnable = False;
//      VertexShader = compile vs_3_0 VS();
//      PixelShader = compile ps_3_0 PSBlur( Blur2ImgSamp );
//   }

#ifdef LENSFLARE

#ifdef HQLENSFLARE
   // get only brighest values for lens flare.
   pass lensflarefirst
   <
      string RenderColorTarget = "BrightpassImg";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();

#ifndef NOSAO
      PixelShader = compile ps_3_0 lensflarefirst( combineFrameSamp );
#else
      PixelShader = compile ps_3_0 lensflarefirst( frameSampler );
#endif
   }

   pass lensflareBlur1H
   <
      string RenderColorTarget = "Blur2Img";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
      PixelShader = compile ps_3_0 BlurH( BrightpassImgSamp );
   }

   pass lensflareBlur1V
   <
      string RenderColorTarget = "BrightpassImg";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
      PixelShader = compile ps_3_0 BlurV( Blur2ImgSamp );
   }

   pass lfBlur3
   <
      string RenderColorTarget = "Blur2Img";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
      PixelShader = compile ps_3_0 PSBlur( BrightpassImgSamp );
   }

   pass lfBlur4
   <
      string RenderColorTarget = "BrightpassImg";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
      PixelShader = compile ps_3_0 PSBlur( Blur2ImgSamp );
   }

   // run the lens flare.
   pass lensflareblur
   <
      string RenderColorTarget = "Blur2Img";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
      PixelShader = compile ps_3_0 lensflare( BrightpassImgSamp );
   }

//   pass lensflareBlurV
//   <
//      string RenderColorTarget = "BrightpassImg";
//   >
//   {
//      ZEnable = False;
//      VertexShader = compile vs_3_0 VS();
//      PixelShader = compile ps_3_0 BlurV( Blur2ImgSamp );
//   }
//   
//   //5. repeat blur texture and save in Blur2Img
//   pass lensflareBlurH
//   <
//      string RenderColorTarget = "Blur2Img";
//   >
//   {
//      ZEnable = False;
//      VertexShader = compile vs_3_0 VS();
//      PixelShader = compile ps_3_0 BlurH( BrightpassImgSamp );
//   }


#else
   pass Lensflarepass
   <
      string RenderColorTarget = "Blur2Img";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
      PixelShader = compile ps_3_0 lensflare( Blur1ImgSamp );
   }
#endif

#endif
   
#ifdef DOF
   pass DepthOfField
   <
      string RenderColorTarget = "DepthOfFieldImg";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
#ifndef NOSAO
      PixelShader = compile ps_3_0 PSDepthOfField( combineFrameSamp );
#else
      PixelShader = compile ps_3_0 PSDepthOfField( frameSampler );
#endif
   }
#endif
   
   pass Present
   <
#ifdef FXAA
      string RenderColorTarget = "buffer1Img";
#else
      string RenderColorTarget = "";
#endif
   >
   {
      VertexShader = compile vs_3_0 VS();
#ifndef NOSAO

#ifdef LENSFLARE
#ifdef DOF
      PixelShader = compile ps_3_0 PSPresent( DepthOfFieldImgSamp, Blur1ImgSamp, AvgLumFinalSamp,Blur2ImgSamp );
#else
      PixelShader = compile ps_3_0 PSPresent( combineFrameSamp, Blur1ImgSamp, AvgLumFinalSamp,Blur2ImgSamp );
#endif
#else
#ifdef DOF
      PixelShader = compile ps_3_0 PSPresent( DepthOfFieldImgSamp, Blur1ImgSamp, AvgLumFinalSamp );
#else
      PixelShader = compile ps_3_0 PSPresent( combineFrameSamp, Blur1ImgSamp, AvgLumFinalSamp );
#endif
#endif

#else

#ifdef LENSFLARE
#ifdef DOF
      PixelShader = compile ps_3_0 PSPresent( DepthOfFieldImgSamp, Blur1ImgSamp, AvgLumFinalSamp,Blur2ImgSamp );
#else
      PixelShader = compile ps_3_0 PSPresent( frameSampler, Blur1ImgSamp, AvgLumFinalSamp,Blur2ImgSamp );
#endif
#else
#ifdef DOF
      PixelShader = compile ps_3_0 PSPresent( DepthOfFieldImgSamp, Blur1ImgSamp, AvgLumFinalSamp );
#else
      PixelShader = compile ps_3_0 PSPresent( frameSampler, Blur1ImgSamp, AvgLumFinalSamp );
#endif
#endif

#endif

   }
#ifdef FXAA
   pass fxaapresent
   <
      string RenderColorTarget = "";
   >
   {
      ZEnable = False;
      VertexShader = compile vs_3_0 VS();
      PixelShader = compile ps_3_0 presentfxaa( buffer1ImgSamp );
   }
#endif


}

